Imports System
Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports IE = Interop.SHDocVw

'Add-in Express .NET for Internet Explorer Module
<ComVisible(True), GuidAttribute("8E85EA85-3A52-454B-939D-274118C48F9D")> _
Public Class IEModule
    Inherits AddinExpress.IE.ADXIEModule

    Friend WithEvents AdxieToolBarItem1 As AddinExpress.IE.ADXIEToolBarItem
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.AdxieToolBarItem1 = New AddinExpress.IE.ADXIEToolBarItem(Me.components)
        '
        'AdxieToolBarItem1
        '
        Me.AdxieToolBarItem1.HelpText = "ADX IE Add-on and Win App"
        Me.AdxieToolBarItem1.LoadAtStartup = True
        Me.AdxieToolBarItem1.MenuText = "ADX IE Add-on and Win App"
        Me.AdxieToolBarItem1.ToolBarType = "ADX_IE_Addon_And_WinApp_VB.WinAppToolBar"
        '
        'IEModule
        '
        Me.ModuleName = "ADX_IE_Addon_And_WinApp_VB"
        Me.ToolBars.Add(Me.AdxieToolBarItem1)

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub RegisterIEModule(ByVal t As Type)
        AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub UnregisterIEModule(ByVal t As Type)
        AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t)
    End Sub

    <ComVisible(True)> _
    Public Class IECustomContextMenuCommands
        Inherits AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher

    End Class

    <ComVisible(True)> _
    Public Class IECustomCommands
        Inherits AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher

    End Class

#End Region

    Public Sub New()
        MyBase.New()

        InitializeComponent()
    End Sub

    Public Sub New(ByVal container As IContainer)
        MyBase.New(container)

        container.Add(Me)
        InitializeComponent()
    End Sub

    Public ReadOnly Property IEApp() As IE.WebBrowser
        Get
            Return CType(Me.IEObj, IE.WebBrowser)
        End Get
    End Property

    Public ReadOnly Property HTMLDocument() As mshtml.HTMLDocument
        Get
            Return CType(Me.HTMLDocumentObj, mshtml.HTMLDocument)
        End Get
    End Property

    Private ADDON_TO_MYAPP_MessageId As IntPtr
    Private MSG_ADDON_TO_MYAPP As String = "ADDON_TO_MYAPP"

    <DllImport("user32.dll")> _
    Public Shared Function RegisterWindowMessage( _
        ByVal lpString As [String]) As IntPtr
    End Function

    <DllImport("user32.dll")> _
    Public Shared Function FindWindow( _
        ByVal lpClassName As String, _
        ByVal lpWindowName As String) As IntPtr
    End Function

    <DllImport("user32.dll")> _
    Public Shared Function PostMessage( _
        ByVal hwnd As IntPtr, _
        ByVal wMsg As IntPtr, ByVal wParam As Int32, _
        ByVal lParam As Int32) As IntPtr
    End Function

    Private Sub IEModule_OnConnect( _
        ByVal sender As System.Object, _
        ByVal threadId As System.Int32) _
        Handles MyBase.OnConnect

        Me.ADDON_TO_MYAPP_MessageId = _
            RegisterWindowMessage(MSG_ADDON_TO_MYAPP)
        SendMessageToMyApp(0)
    End Sub

    Private Sub IEModule_OnDisconnect( _
        ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
        Handles MyBase.OnDisconnect

        SendMessageToMyApp(1000)
    End Sub

    Private Sub IEModule_DocumentComplete( _
        ByVal pDisp As System.Object, _
        ByVal url As System.String) _
        Handles MyBase.DocumentComplete

        SendMessageToMyApp(0)
    End Sub

    Private Sub SendMessageToMyApp(ByVal delay As Integer)
        Dim hwnd As IntPtr = FindWindow(Nothing, "My Application")
        If hwnd <> IntPtr.Zero Then
            PostMessage(hwnd, Me.ADDON_TO_MYAPP_MessageId, delay, 0)
        End If
    End Sub

    Public Function GetCurrentTitle() As String
        Try
            Dim text As String = Me.HTMLDocument.title
            If [String].IsNullOrEmpty(text) Then
                text = "Blank Page"
            End If
            Return text
        Catch
        End Try
        Return [String].Empty
    End Function

    Public Sub NavigateTo(ByVal url As String)
        Try
            Dim dummy As Object = Type.Missing
            Me.IEApp.Navigate(url, dummy, dummy, dummy, dummy)
        Catch err As Exception
            MessageBox.Show(err.Message, Me.ModuleName, _
                MessageBoxButtons.OK, MessageBoxIcon.[Error])
        End Try
    End Sub
End Class

